import json
from copy import deepcopy

def fix_em_all(schema_name):
    schema_filename = schema_name + '.json'
    with open(schema_filename) as infile:
        j_schema_raw = json.load(infile)

    j_schema_better = deepcopy(j_schema_raw)
    config_node = j_schema_better['config']
    for root in config_node:
        config_root = config_node[root]
        # if root == 'Infection' and 'Infectious_Period_Constant' not in config_root:
        #     inf_per_const = {
        #         "default": 10,
        #         "depends-on": {
        #             "Infectious_Period_Distribution": "CONSTANT_DISTRIBUTION"
        #         },
        #         "description": "Chris Wiswell added this because of GH 3693",
        #         "max": 1000,
        #         "min": 0,
        #         "type": "float"
        #     }
        #     j_schema_better['config'][root]['Infectious_Period_Constant'] = inf_per_const
        for param in config_root:
            config_param = config_root[param]
            if 'type' in config_param:
                fixed_default = None
                if config_param['type'] == 'Vector String' and 'serialized' not in param.lower():
                    fixed_default = []
                elif config_param['type'] == 'enum' and 'initialized' in config_param['default'].lower():
                    fixed_default = config_param['enum'][1]
                elif param == 'Enable_Demographics_Builtin':
                    fixed_default = 1
                elif param == 'Load_Balance_Filename':
                    fixed_default = ""
                elif param == ('Infectious_Period_Constant'):
                    fixed_default = 1
                elif param == ('Incubation_Period_Constant'):
                    fixed_default = 1
                if fixed_default is not None:
                    j_schema_better['config'][root][param]['default'] = fixed_default
                    old_description = j_schema_better['config'][root][param]['description']
                    new_description = old_description + ' ALSO CWISWELL CHANGED THIS TO MAKE IT WORK'
                    j_schema_better['config'][root][param]['description'] = new_description



    schema_better_filename = schema_name + '_fixed' + '.json'
    with open(schema_better_filename, 'w') as outfile:
        json.dump(j_schema_better, outfile, indent=4, sort_keys=True)

fix_em_all('generic-schema-processed')